///////////////////////////////////////////////////////////////////////////////
//ǽХʸ˴ؤؿ
//⡧UNIX ѡ
//Copyright (C) 2001-2002 Takashi Sugiyama. All Rights Reserved.
///////////////////////////////////////////////////////////////////////////////
#include "TSMBS.h"
#include <stdio.h> //NULL
#include <string.h> //strlen(),strstr()

///////////////////////////////////////////////////////////////////////////////
//ǽEUC ʸɤμ̤롣
//⡧Ⱦѥ 0x8E,0xA0  0x8E,0xDF
//           0xA1,0xA1  0xA1,0xFE
//                
//               0xFE,0xA1  0xFE,0xFE
//ֵ͡=TSMBS_CHARACTER		:Хʸ
//        =TSMBS_KANJI_LEAD		:ɤԥХ
//        =TSMBS_KANJI_TRAIL		:ɤθ³Х
//        =TSMBS_HANKANA_LEAD	:ȾѥʤԥХ
//        =TSMBS_HANKANA_TRAIL	:Ⱦѥʤθ³Х
//СV1.0.0 2001/11/16 
///////////////////////////////////////////////////////////////////////////////
int TSMBS_GetCodeTypeEUC(
const unsigned char *pszTop,
const unsigned char *pszTrgt
)
{
	unsigned int wOfst = 0, wInc = 0;
	const unsigned char *p = 0;
	int iCode = 0;

	while ( 1 )
	{
		p = pszTop+wOfst;
		if ((unsigned char)0xA1 <= *p && *p <= (unsigned char)0xfe ) //ԥХ
		{
			iCode = TSMBS_KANJI_LEAD;
			wInc = 2;
		}
		else if ( *p == (unsigned char)0x8e ) //ȾѥʤԥХ
		{
			iCode = TSMBS_HANKANA_LEAD;
			wInc = 2;
		}
		else
		{
			iCode = TSMBS_CHARACTER;
			wInc = 1;
		}
		if ( p == pszTrgt ) //ɸΥݥ󥿤ʤ
			break;
		if ( p+1 == pszTrgt ) //ɸݥ󥿤ΰļʤ
		{
			if ( iCode == TSMBS_KANJI_LEAD )
			{
				iCode = TSMBS_KANJI_TRAIL;
				break;
			}
			if ( iCode == TSMBS_HANKANA_LEAD )
			{
				iCode = TSMBS_HANKANA_TRAIL;
				break;
			}
		}
		wOfst += wInc;
	}
	return iCode;
}

///////////////////////////////////////////////////////////////////////////////
//ǽ_ismbslead() Ʊ
//ֵ͡_ismbslead() Ʊ
//        =-1:ԥХ  =0:¾
//СV1.1.0 2001/12/25 
///////////////////////////////////////////////////////////////////////////////
int TSC_ismbslead(
const unsigned char *pszTop, //(I)Ƭݥ󥿡ޤԥХȤؤΥݥ
const unsigned char *pszTrgt //(I)åݥ
)
{
	int iRet = 0;

	iRet = TSMBS_GetCodeTypeEUC( pszTop, pszTrgt );
	if ( iRet == TSMBS_KANJI_LEAD || iRet == TSMBS_HANKANA_LEAD )
		return -1;
	return 0;
}

///////////////////////////////////////////////////////////////////////////////
//ǽ_ismbstrail() Ʊ
//ֵ͡_ismbslead() Ʊ
//        =-1:³Х  =0:¾
//СV1.1.0 2001/12/25 
///////////////////////////////////////////////////////////////////////////////
int TSC_ismbstrail(
const unsigned char *pszTop, //(I)Ƭݥ󥿡ޤԥХȤؤΥݥ
const unsigned char *pszTrgt //(I)åݥ
)
{
	int iRet = 0;

	iRet = TSMBS_GetCodeTypeEUC( pszTop, pszTrgt );
	if ( iRet == TSMBS_KANJI_TRAIL || iRet == TSMBS_HANKANA_TRAIL )
		return -1;
	return 0;
}

///////////////////////////////////////////////////////////////////////////////
//ǽХʸθ strstr()
//    VisualC++  _mbsstr() 򥨥ߥ졼ȡ
//ֵܲ͡Ȥ strstr() ˽ऺ롣
//СV1.0.0 2001/11/17 
//          V1.1.0 2001/12/26 
//                   TSLB_IsLeadByte()  TSC_ismbstrail() ѡ
///////////////////////////////////////////////////////////////////////////////
unsigned char *TSC_mbsstr(
const unsigned char *pszBase, //(I)ʸ
const unsigned char *pszFind //(I)ʸ
)
{
	unsigned int wFindLen = 0;
	char *p = NULL;
	const char *pszNext = NULL;

	wFindLen = strlen((char*)pszFind );
	pszNext = (const char*)pszBase;
	while ( 1 )
	{
		p = strstr( pszNext, (char*)pszFind );
		if ( !p || !wFindLen )
			break;
		if ( !TSC_ismbstrail( pszBase, (unsigned char*)p )) //³ХȤǤʤʤ
			break;
		pszNext = p+1;
	}
	return (unsigned char*)p;
}
